--------------------------------------------------------
--SoftLight scripted plug-in Tutorial FINAL CODE v1.01
--by Borislav 'Bobo' Petrov
--http://www.gfxcentral.com/bobo/mxs4/tuts/
--------------------------------------------------------


plugin Light SoftLight
name:"SoftLight"
classId:#(0x4e60b08c, 0x5ecd8b38)
extends:TargetSpot
category:"FilmAkademie"
(	
parameters softlight rollout:softlight_roll
(
numlights 	type:#integer 	default:42 		animatable:false 	ui:numlights
radius 		type:#float 	default:20 		animatable:true 	ui:radius
usesoft 	type:#boolean 	default:true	animatable:false 	ui:usesoft
onstate		type:#boolean 	default:true	animatable:false 	
)

rollout softlight_roll "SoftLight Parameters"
(
checkbox usesoft "Use Soft Mode" 
spinner numlights "# Lights:" range:[3,1000,42] type:#integer
spinner radius "Radius:" range:[0,100000,20]
)

on create do
(
callbacks.removescripts id:#softLight
txt = "lights_array = Lights as array\n"
txt +="for s in lights_array where classof s == SoftLight do(\n"
txt +="if s.usesoft then (\n"
txt +="helix_path = helix radius1:20 radius2:0 height:0 turns:5\n"
txt +="try(helix_path.radius1.controller = s.radius.controller)catch(helix_path.radius1 = s.radius)\n"
txt +="helix_path.pos = s.pos\n"
txt +="helix_path.transform.controller = lookat()\n"
txt +="helix_path.lookat = copy s.target\n"
txt +="helix_path.name = uniquename \"SoftLight_Temp\" \n"
txt +="helix_path.parent = s \n"
txt +="num_lights = s.numlights\n"
txt +="for i = 1 to num_lights do \n("
txt +="new_light = copy s\n"
txt +="new_target = copy s.target\n"
txt +="new_light.target = new_target \n"
txt +="new_light.target_spot.multiplier = s.delegate.multiplier / num_lights\n"
txt +="new_light.name = uniquename \"SoftLight_Temp\"  \n"
txt +="new_light.target_spot.raytracedShadows = s.delegate.raytracedShadows \n"
txt +="new_light.pos.controller = path path:helix_path\n"
txt +="deleteKeys new_light.pos.controller.percent.keys #allkeys\n"
txt +="new_light.pos.controller.percent=(100.0*i/num_lights)\n)\n"
txt +="s.onstate = s.delegate.on\n"
txt +="s.delegate.on = false\n))\n"
callbacks.addScript #preRender txt id:#softLight persistent:true

txt ="delete $SoftLight_Temp*\n"
txt += "for s in Lights where classof s == SoftLight do(\n"
txt += "if s.usesoft then s.delegate.on = s.onstate)\n"
callbacks.addScript #postRender txt id:#softLight persistent:true
)

)--end plug-in